#!/bin/bash
#
# gopherd.sh - an experimental gopher server implementation written in bash
# (c) 2002 by Matthias Arndt <marndt@asmsoftware.de>
# published by ASM Software http://www.asmsoftware.de/
# 
# May 22 2002: v0.09b
# May 23 2002: v0.1 (as published)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#

# some defines - set this to the actual network reachable hostname or IP
SERVER=localhost
# set this to the TCP port number where this simple daemon is bound to.. (default is 70 for gopher)
PORT=70

# read the selector from the client
read REQUEST1

# convert selector to Unix conventions as Gopher clients use CR/LF instead of LF
REQUEST=`echo $REQUEST1|recode ibmpc..lat1 2>/dev/null`

# process the request...
case $REQUEST in
GPL)
    # supply a path to a local copy of the GNU GPL here...
    cat /usr/src/linux/COPYING
    ;;
UU)
    # insert path to gopherd.sh here - to let others download this tool via gopher
    uuencode /gopherd.sh gopherd.sh
    ;;
ABOUT)
    echo "Experimental Gopher Server"
    echo "(c) 2002 by Matthias Arndt <marndt@asmsoftware.de>"
    echo "The GNU General Public License applies to this little program."
    echo
    echo "Use at your own risk! NO WARRANTY!"
    echo
    echo "Use TCP wrapper and inetd to test it over the net."
    ;;
MENU)
    echo -e "iProject Menu\t\t$SERVER\t$PORT\t\r"
    echo -e "0About Experimental Gopher Server\tABOUT\t$SERVER\t$PORT\t\r"
    echo -e "6Download UUencoded...\tUU\t$SERVER\t$PORT\t\r"
    ;;
*)
    # Hauptdirectory....
    echo -e "iExperimental Gopher Server at $SERVER\t\t$SERVER\t$PORT\t\r"
    echo -e "i(c) 2002 by Matthias Arndt <marndt@asmsoftware.de>\t\t$SERVER\t$PORT\t\r"
    echo -e "0GNU General Public License\tGPL\t$SERVER\t$PORT\t\r"
    echo -e "1Project Menu...\tMENU\t$SERVER\t$PORT\t\r"
    ;;
esac

# Terminate Gopher output
echo "."
